unit dllLoader;

interface

uses
  Windows,
  SysUtils,
  OmegaScreen,
  OmegaImageList,
  OmegaSprite,
  OmegaFont,
  OmegaBitmapFont,
  OmegaInput;

var InitDll: procedure(AOmegaScreen: pointer; AOmegaImageList: pointer; AOmegaSprite: pointer;
               AOmegaFont: pointer; AOmegaBitmapFont: pointer; AOmegaInput: pointer);
    UpdateDll: procedure(UpdateTime: Single);
    GetPicPath: function: PChar;

var hDll : THandle;
    procedure FreeDll;
    procedure LoadDll(const dll: String);

implementation

procedure FreeDll;
begin
 @InitDll := nil;
 @UpdateDll := nil;
 @GetPicPath := nil;
 FreeLibrary(hDll);
end;

procedure LoadDll(const dll: String);
begin
 FreeDll;
 hDll := LoadLibrary(PChar(dll));
 if hDll = 0 then raise Exception.Create('Couldn''t load ' + dll);
 @InitDll := GetProcAddress(hDll, 'InitDll');
 @UpdateDll := GetProcAddress(hDll, 'UpdateDll');
 @GetPicPath := GetProcAddress(hDll, 'GetPicPath');
 if (not Assigned(InitDll)) or (not Assigned(UpdateDll)) then
  raise Exception.Create('Not all methods are assigned');
end;

initialization
//  LoadDll('BaseDll.dll');

finalization
 FreeDll;

end.
 