unit TileProperties;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, module, Mask;

type
  TfrmTileProp = class(TForm)
    Label3: TLabel;
    UpDown1: TUpDown;
    Label1: TLabel;
    UpDown2: TUpDown;
    editTileGreen: TEdit;
    Label2: TLabel;
    UpDown3: TUpDown;
    editTileBlue: TEdit;
    Label4: TLabel;
    UpDown4: TUpDown;
    editTileAlpha: TEdit;
    CheckBox1: TCheckBox;
    Label5: TLabel;
    UpDown5: TUpDown;
    editTileAnimCount: TEdit;
    ComboBox1: TComboBox;
    Label6: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label9: TLabel;
    UpDown8: TUpDown;
    editTileRotation: TEdit;
    Label10: TLabel;
    UpDown9: TUpDown;
    editTileAnimSpeed: TEdit;
    editTileRed: TEdit;
    procedure editTileRedChange(Sender: TObject);
    procedure editTileGreenChange(Sender: TObject);
    procedure editTileBlueChange(Sender: TObject);
    procedure editTileAlphaChange(Sender: TObject);
    procedure Refresh;
    procedure CheckBox1Click(Sender: TObject);
    procedure editTileAnimSpeedChange(Sender: TObject);
    procedure editTileAnimCountChange(Sender: TObject);
    procedure editTileRotationChange(Sender: TObject);
  private
    { Private declarations }
  public

  end;

var
  frmTileProp: TfrmTileProp;

implementation

uses unit1;

{$R *.dfm}

procedure TFrmTileProp.Refresh;
begin
  if Module1.CanRender then
    begin
      editTileRed.Text := IntToStr(Module1.Red);
      editTileGreen.Text := IntToStr(Module1.Green);
      editTileBlue.Text := IntToStr(Module1.Blue);
      editTileAlpha.Text := IntToStr(Module1.Alpha);
      editTileRotation.Text := IntToStr(Module1.Rotation);
      editTileAnimCount.Text := IntToStr(Module1.AnimCount);
      editTileAnimSpeed.Text := IntToStr(Module1.AnimSpeed);

      if Module1.AnimateTile then
        checkbox1.Checked := true
      else
        checkbox1.Checked := false;
      
    end;
end;

procedure TfrmTileProp.editTileRedChange(Sender: TObject);
begin
  if (Module1.CanRender) and (Module1.CurrentMode = 'edittile') then
    begin
      if Module1.CurrentLayer = 1 then frmMain.Layer1[Module1.CurrentEditTileX,Module1.CurrentEditTileY].R := StrToInt(editTileRed.text);
      if Module1.CurrentLayer = 2 then frmMain.Layer2[Module1.CurrentEditTileX,Module1.CurrentEditTileY].R := StrToInt(editTileRed.text);
      if Module1.CurrentLayer = 3 then frmMain.Layer3[Module1.CurrentEditTileX,Module1.CurrentEditTileY].R := StrToInt(editTileRed.text);
    end;
end;

procedure TfrmTileProp.editTileGreenChange(Sender: TObject);
begin
  if (Module1.CanRender) and (Module1.CurrentMode = 'edittile') then
    begin
      if Module1.CurrentLayer = 1 then frmMain.Layer1[Module1.CurrentEditTileX,Module1.CurrentEditTileY].G := StrToInt(editTileGreen.text);
      if Module1.CurrentLayer = 2 then frmMain.Layer2[Module1.CurrentEditTileX,Module1.CurrentEditTileY].G := StrToInt(editTileGreen.text);
      if Module1.CurrentLayer = 3 then frmMain.Layer3[Module1.CurrentEditTileX,Module1.CurrentEditTileY].G := StrToInt(editTileGreen.text);
    end;
end;

procedure TfrmTileProp.editTileBlueChange(Sender: TObject);
begin
  if (Module1.CanRender) and (Module1.CurrentMode = 'edittile') then
    begin
      if Module1.CurrentLayer = 1 then frmMain.Layer1[Module1.CurrentEditTileX,Module1.CurrentEditTileY].B := StrToInt(editTileBlue.text);
      if Module1.CurrentLayer = 2 then frmMain.Layer2[Module1.CurrentEditTileX,Module1.CurrentEditTileY].B := StrToInt(editTileBlue.text);
      if Module1.CurrentLayer = 3 then frmMain.Layer3[Module1.CurrentEditTileX,Module1.CurrentEditTileY].B := StrToInt(editTileBlue.text);
    end;
end;

procedure TfrmTileProp.editTileAlphaChange(Sender: TObject);
begin
  if (Module1.CanRender) and (Module1.CurrentMode = 'edittile') then
    begin
      if Module1.CurrentLayer = 1 then frmMain.Layer1[Module1.CurrentEditTileX,Module1.CurrentEditTileY].A := StrToInt(editTileAlpha.text);
      if Module1.CurrentLayer = 2 then frmMain.Layer2[Module1.CurrentEditTileX,Module1.CurrentEditTileY].A := StrToInt(editTileAlpha.text);
      if Module1.CurrentLayer = 3 then frmMain.Layer3[Module1.CurrentEditTileX,Module1.CurrentEditTileY].A := StrToInt(editTileAlpha.text);
    end;
end;

procedure TfrmTileProp.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
    if (Module1.CanRender) and (Module1.CurrentMode = 'edittile') then
      begin
        if Module1.CurrentLayer = 1 then
          begin
            frmMain.Layer1[Module1.CurrentEditTileX,Module1.CurrentEditTileY].DoAnimate := True;
            frmMain.Layer1[Module1.CurrentEditTileX,Module1.CurrentEditTileY].ImageIndex := frmMain.Layer1[Module1.CurrentEditTileX,Module1.CurrentEditTileY].I;
          end;

        if Module1.CurrentLayer = 2 then
          begin
            frmMain.Layer2[Module1.CurrentEditTileX,Module1.CurrentEditTileY].DoAnimate := True;
            frmMain.Layer2[Module1.CurrentEditTileX,Module1.CurrentEditTileY].ImageIndex := frmMain.Layer2[Module1.CurrentEditTileX,Module1.CurrentEditTileY].I;
          end;

        if Module1.CurrentLayer = 3 then
          begin
            frmMain.Layer3[Module1.CurrentEditTileX,Module1.CurrentEditTileY].DoAnimate := True;
            frmMain.Layer3[Module1.CurrentEditTileX,Module1.CurrentEditTileY].ImageIndex := frmMain.Layer3[Module1.CurrentEditTileX,Module1.CurrentEditTileY].I;
          end;
      end;

  if CheckBox1.Checked = False then
    if (Module1.CanRender) and (Module1.CurrentMode = 'edittile') then
      begin
        if Module1.CurrentLayer = 1 then frmMain.Layer1[Module1.CurrentEditTileX,Module1.CurrentEditTileY].DoAnimate := False;
        if Module1.CurrentLayer = 2 then frmMain.Layer2[Module1.CurrentEditTileX,Module1.CurrentEditTileY].DoAnimate := False;
        if Module1.CurrentLayer = 3 then frmMain.Layer3[Module1.CurrentEditTileX,Module1.CurrentEditTileY].DoAnimate := False;
      end;
end;

procedure TfrmTileProp.editTileAnimSpeedChange(Sender: TObject);
begin
  if (Module1.CanRender) and (Module1.CurrentMode = 'edittile') then
    begin
      if Module1.CurrentLayer = 1 then frmMain.Layer1[Module1.CurrentEditTileX,Module1.CurrentEditTileY].AnimSpeed := StrToInt(editTileAnimSpeed.Text);
      if Module1.CurrentLayer = 2 then frmMain.Layer2[Module1.CurrentEditTileX,Module1.CurrentEditTileY].AnimSpeed := StrToInt(editTileAnimSpeed.Text);
      if Module1.CurrentLayer = 3 then frmMain.Layer3[Module1.CurrentEditTileX,Module1.CurrentEditTileY].AnimSpeed := StrToInt(editTileAnimSpeed.Text);
    end;
end;

procedure TfrmTileProp.editTileAnimCountChange(Sender: TObject);
begin
  if (Module1.CanRender) and (Module1.CurrentMode = 'edittile') then
    begin
      if Module1.CurrentLayer = 1 then frmMain.Layer1[Module1.CurrentEditTileX,Module1.CurrentEditTileY].AnimCount := StrToInt(editTileAnimCount.Text);
      if Module1.CurrentLayer = 2 then frmMain.Layer2[Module1.CurrentEditTileX,Module1.CurrentEditTileY].AnimCount := StrToInt(editTileAnimCount.Text);
      if Module1.CurrentLayer = 3 then frmMain.Layer3[Module1.CurrentEditTileX,Module1.CurrentEditTileY].AnimCount := StrToInt(editTileAnimCount.Text);
    end;
end;

procedure TfrmTileProp.editTileRotationChange(Sender: TObject);
begin
  if (Module1.CanRender) and (Module1.CurrentMode = 'edittile') then
    begin
      if Module1.CurrentLayer = 1 then frmMain.Layer1[Module1.CurrentEditTileX,Module1.CurrentEditTileY].Rotation := StrToInt(editTileRotation.Text);
      if Module1.CurrentLayer = 2 then frmMain.Layer2[Module1.CurrentEditTileX,Module1.CurrentEditTileY].Rotation := StrToInt(editTileRotation.Text);
      if Module1.CurrentLayer = 3 then frmMain.Layer3[Module1.CurrentEditTileX,Module1.CurrentEditTileY].Rotation := StrToInt(editTileRotation.Text);
    end;
end;

end.
