unit TileSelect;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Menus, ExtDlgs, Module, StdCtrls;

type
  TfrmTileSelect = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    OpenPictureDialog1: TOpenPictureDialog;
    Image2: TImage;
    Label1: TLabel;
    Panel1: TPanel;
    Image1: TImage;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Edit1: TEdit;
    procedure Open1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    fLoaded : boolean;
  public

  end;

var
  frmTileSelect: TfrmTileSelect;

implementation

{$R *.dfm}

procedure TfrmTileSelect.Open1Click(Sender: TObject);
var
  TempPic : TBitmap;
begin
  if OpenPictureDialog1.Execute then
    try
      TempPic := TBitmap.Create;
      TempPic.LoadFromFile(OpenPictureDialog1.Filename);
      Image1.Picture.Bitmap := TempPic;
      TempPic.Free;
      Image1.Width := Image1.Picture.Width;
      Image1.Height := Image1.Picture.Height;
      Module1.UpdateImage(OpenPictureDialog1.FileName);
      FLoaded := True;
      ScrollBar1.Max := Image1.Width;
      ScrollBar2.Max := Image1.Height;
      ScrollBar1.Enabled := True;
      ScrollBar2.Enabled := True;
      Module1.CanRender := true;
      
    finally
    end;
end;

procedure TfrmTileSelect.FormCreate(Sender: TObject);
begin
  FLoaded := False;
end;

procedure TfrmTileSelect.Image1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var TempRect : TRect;
    TempBmp  : TBitmap;
    col,row  : integer;
    tX,tY : integer;
begin
  if FLoaded then
    begin
      TempRect.Left := (X div Module1.TileWidth) * Module1.TileWidth;
      TempRect.Right := TempRect.Left + Module1.TileWidth;
      TempRect.Top := (Y div Module1.TileHeight) * Module1.TileHeight;
      TempRect.Bottom := TempRect.Top + Module1.TileHeight;

      TempBmp := TBitmap.Create;
      TempBmp.Width := Image2.Width;
      TempBmp.Height := Image2.Height;

      TempBmp.Canvas.CopyRect(rect(0,0,image2.Width,image2.Height),Image1.Canvas,TempRect);

      Image2.Picture.Bitmap := TempBmp;

      TempBmp.Free;

      Image1.Picture.LoadFromFile(OpenPictureDialog1.FileName);

      Image1.Canvas.Pen.Style := psClear;
      Image1.Canvas.Pen.Width := 1;
      Image1.Canvas.FrameRect(TempRect);
    end;
end;

procedure TfrmTileSelect.ScrollBar1Change(Sender: TObject);
begin
  Image1.Left := - ScrollBar1.Position;
end;

procedure TfrmTileSelect.ScrollBar2Change(Sender: TObject);
begin
  Image1.Top := - ScrollBar2.Position;
end;

procedure TfrmTileSelect.Image1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var tx,ty : integer;
begin
  tx:=trunc(Int(X / Module1.TileWidth));
  ty:=trunc(Int(Y / Module1.TileHeight));

  edit1.Text := inttostr((tx + Module1.TileHeight * ty));

  Module1.CurrentTile := tx + Module1.TileHeight * ty;
end;

end.
