unit Unit1;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OmegaImageList, OmegaScreen, OmegaInput, OmegaBitmapFont,
  OmegaTimer, OmegaSprite, OmegaUtils, {$I UseD3D8.inc};

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;   
    OmegaImageList1: TOmegaImageList;
    OmegaTimer1: TOmegaTimer;
    OmegaBitmapFont1: TOmegaBitmapFont;
    OmegaInput1: TOmegaInput;
    procedure FormCreate(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OmegaScreen1Init(Sender: TObject);
  end;

var Form1: TForm1;
    angle: single;
    bgp, fgp, bm: integer;
    bmstr: string;
    cols, showspot: boolean;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 self.ClientWidth := 800;
 self.ClientHeight := 600;
 OmegaScreen1.Width := self.ClientWidth;
 OmegaScreen1.Height := self.ClientHeight;
 OmegaScreen1.Init;
 showspot := true;
 cols := true;
 bmstr := 'bmNormal';
 bm := 0;
 bgp := 0;
 fgp := 0;
 OmegaTimer1.Enabled := True;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var x, y: integer;
    s, s2, c, c2,  // sine and cosine variables
    t, t2, t3, t4, t5: single; // temporary variables
begin
 if not OmegaScreen1.CanDraw then exit;
 OmegaInput1.Update;
 if oisbutton1 in OmegaInput1.keyboard.statesclicked then
  OmegaScreen1.ToggleFullScreen;
 OmegaScreen1.ClearScreen(0, 0, 0, 0);
 OmegaScreen1.BeginRender;

 angle := angle + 0.5;
 if angle >= 360 then angle := angle - 360;
 s := sin(angle * pi / 180);
 s2 := sin(pi + (4 * angle * pi / 180));
 c := cos(angle * pi / 180);
 c2 := cos(pi + (4 * angle * pi / 180));

 if bgp=3 then t5 := 100 else t5 := 1;
 // draw background
 for x := 0 to 2 do
  for y := 0 to 1 do
   OmegaImageList1.ImageList.Items[bgp].Draw(
   x*256, y*256, 0, 0, 0, t5, t5,
    OmegaColor(255, 255, 255, 255), -1);

 OmegaScreen1.SetBlendMode(bm);

 if showspot then
 begin
  // draw spotlight
  t  := 150 + 200 * s;
  t2 := 50 + 100 * c2;
  t3 := 100 * (s2 + 1.5);  // color movement
  t4 := 100 * (c + 1.5);   // color movement
  t5 := 120 * (s2 + 1.5);  // color movement
  if fgp=3 then t5 := t5*100;
  if cols then
  OmegaImageList1.ImageList.Items[fgp].Draw(
   round(t), round(t2), // position
   0, 0, 0, // rotation angle and center
   (t + t5) / 100, t5 / 50, // scaling
   OmegaColor(round(t3), round(t4), 255 - round(t3), 255), -1, bmIgnore)
  else
  OmegaImageList1.ImageList.Items[fgp].Draw(
   round(t), round(t2), // position
   0, 0, 0, // rotation angle and center
   (t + t5) / 100, t5 / 50, // scaling
   OmegaColor(255, 255, 255, 255), -1, bmIgnore);
 end;

 OmegaScreen1.SetBlendMode(bmNormal);
 OmegaBitmapFont1.Print(40, 510, 'Press "1" to change background sprite');
 OmegaBitmapFont1.Print(40, 530, 'Press "2" to change foreground sprite');
 OmegaBitmapFont1.Print(40, 550, 'Press "B" to change BlendMode');
 OmegaBitmapFont1.Print(440, 510, 'Press "space" to toggle fullscreen');
 OmegaBitmapFont1.Print(440, 530, 'BlendMode: ' + bmstr);
 OmegaBitmapFont1.Print(440, 550, 'Press "C" to toggle color cycling');
 OmegaScreen1.EndRender;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 OmegaTimer1.Enabled := False;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i,x,y:integer;
begin
 if key = 27 then close;
 if key = ord('S') then showspot := not showspot;
 if key = ord('C') then cols := not cols;
 if key = ord('1') then bgp := (bgp + 1) mod 4;
 if key = ord('2') then fgp := (fgp + 1) mod 4;
 if key = ord('B') then
 begin
  bm := (bm + 1) mod 14;
  case bm of
  bmNormal: bmstr := 'bmNormal';
  bmAdd: bmstr := 'bmAdd';
  bmSrcAdd: bmstr := 'bmSrcAdd';
  bmSrcCol: bmstr := 'bmSrcCol';
  bmSrcColAdd: bmstr := 'bmSrcColAdd';
  bmMultiply: bmstr := 'bmMultiply';
  bmMultiplyAlpha: bmstr := 'bmMultiplyAlpha';
  bmInvMultiply: bmstr := 'bmInvMultiply';
  bmInvMultiplyAlpha: bmstr := 'bmInvMultiplyAlpha';
  bmInvert: bmstr := 'bmInvert';
  bmSrcBright: bmstr := 'bmSrcBright';
  bmDestBright: bmstr := 'bmDestBright';
  bmInvSrcBright: bmstr := 'bmInvSrcBright';
  bmInvDestBright: bmstr := 'bmInvDestBright';
  else
  end;
 end; 
end;

procedure TForm1.OmegaScreen1Init(Sender: TObject);
begin
 ColorToAlpha(OmegaImageList1.ImageList.Items[0].Image, 1, 0, 0, 0);
end;

end.



