unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OmegaImageList, OmegaScreen, OmegaTimer,
  OmegaBitmapFont, OmegaSprite, OmegaInput;

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaTimer1: TOmegaTimer;
    OmegaBitmapFont1: TOmegaBitmapFont;
    OmegaBitmapFont2: TOmegaBitmapFont;
    OmegaInput1: TOmegaInput;
    procedure FormCreate(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OmegaScreen1Init(Sender: TObject);
  end;

var Form1: TForm1;
    angle: single;
    CurFont: integer;
    antialias, showspot: boolean;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 self.ClientWidth := 800;
 self.ClientHeight := 600;
 OmegaScreen1.Width := self.ClientWidth;
 OmegaScreen1.Height := self.ClientHeight;
 OmegaScreen1.Init;
 OmegaInput1.Initialize;
 CurFont := 0;

 showspot := true;
 antialias := false;
 OmegaTimer1.Enabled := True;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var x, y: integer;
    s, c, s2, c2,   // sine and cosine variables
    t, t2, t3, t4, t5: single; // temporary variables
begin
 if not OmegaScreen1.CanDraw then exit;
 OmegaInput1.Update;
 if oisbutton1 in OmegaInput1.keyboard.statesclicked then
  OmegaScreen1.ToggleFullScreen;
  
 OmegaScreen1.BeginRender;
 
 OmegaScreen1.ClearScreen(0, 0, 0, 0);

 angle := angle + 0.5;
 if angle >= 360 then angle := angle - 360;

 s := sin(angle * pi / 180);
 c := cos(angle * pi / 180);
 s2 := sin(pi + (4 * angle * pi / 180));
 c2 := cos(pi + (2 * angle * pi / 180));

 // draw background
 for x := 0 to 2 do
  for y := 0 to 1 do
   OmegaImageList1.ImageList.Items[1].Draw(
   x*256, y*256, 0, 0, 0, 1, 1,
    OmegaColor(255, 255, 255, 255), -1);

 OmegaScreen1.SetAntiAliasing(false);
 OmegaBitmapFont2.Print(40, 15, 'Press "F" to change fonts');
 OmegaBitmapFont2.Print(545, 15, 'Press "A" for antialiasing');
 OmegaBitmapFont2.Print(275, 15, 'Press "space" for fullscreen');
 Omegascreen1.SetAntiAliasing(antialias);

 OmegaBitmapFont1.OmegaImageIndex := CurFont + 2;
 OmegaBitmapFont1.CharRotation := 180 * (s2 + 1);
 OmegaBitmapFont1.PositionMode := pmCenter;
 OmegaBitmapFont1.Print4Col(350, 240, 180 * (s + 1), 1, 1,
 OmegaColor($FFFFFFFF), OmegaColor($FFFFFFFF),
 OmegaColor($FFFFFFFF), OmegaColor($FFFFFFFF),
 'font test');

 t := 55 + (100 * (c + 1));
 OmegaBitmapFont1.CharRotation := 0;
 OmegaBitmapFont1.PositionMode := pmTopLeft;
 OmegaBitmapFont1.Print4Col(200, 340, 180 * (c2 + 1), 1.5, 1.5,
 OmegaColor(0, 0, 255, round(t)),
 OmegaColor(0, 0, 255, round(t)),
 OmegaColor(0, 255, 255, round(t)),
 OmegaColor(0, 255, 255, round(t) div 2),
 'font test');

 OmegaBitmapFont1.Spacing := round(100 * abs(s)) - 90;
 OmegaBitmapFont1.Print4Col(380, 440, 0, 1.5, 1.5,
 OmegaColor(255, 0, 255, 255),
 OmegaColor(0, 255, 255, 255),
 OmegaColor(255, 255, 255, 0),
 OmegaColor(255, 255, 255, 0),
 'font test');
 OmegaBitmapFont1.Spacing := 0;

 OmegaBitmapFont2.Print4Col(35, 65, 90, 1, 1,
  OmegaColor(255, 255, 255),
  OmegaColor(255, 0, 255),
  OmegaColor(255, 255, 255),
  OmegaColor(255, 0, 150),
  'Font name: ' + OmegaBitmapFont1.Fontname);

 Omegascreen1.SetBlendMode(bmSrcAdd);
 t:=155+(50*(s+1));
 OmegaBitmapFont1.Print4Col(30, round(2.5*t-320), 0, 5, 5,
 OmegaColor(0, 255, 0, 255),
 OmegaColor(255, 0, 0, 255),
 OmegaColor(255, 0, 255, 255),
 OmegaColor(90, 255, 255, 255),
 'tob', bmIgnore);
 OmegaBitmapFont1.CharRotation := 360 * abs(s);
 OmegaBitmapFont1.Print4Col(30 + 3 * OmegaBitmapFont1.CharWidth * 5,
 round(2.5 * t - 320), 0, 5, 5,
 OmegaColor(0, 255, 0, 255),
 OmegaColor(255, 0, 0, 255),
 OmegaColor(255, 0, 255, 255),
 OmegaColor(90, 255, 255, 255),
 'y', bmIgnore);

 if showspot then
 begin
  // draw spotlight
  t  := 200 + 200 * s;
  t2 := 100 + 100 * c2;
  t3 := 100 * (s2 + 1.5);  // color movement
  t4 := 100 * (c + 1.5);   // color movement
  t5 := 120 * (s2 + 1.5);  // color movement
  OmegaImageList1.ImageList.Items[0].Draw(
   round(t), round(t2), // position
   0, 0.5, 0.5, // rotation angle and center
   (t + t5) / 200, t5 / 100, // scaling
   OmegaColor(round(t3), round(t4), 255-round(t3), 255), -1, bmIgnore);
 end;

 OmegaScreen1.EndRender;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 OmegaTimer1.Enabled := False;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key = 27 then close;
 if key = ord('S') then showspot := not showspot;
 if key = ord('A') then antialias := not antialias;
 if key = ord('F') then
 begin
  CurFont := (CurFont + 1) mod 5;
  case CurFont of
  0: begin
      OmegaBitmapFont1.OmegaImageIndex := 2;
      OmegaBitmapFont1.Characters:=' !"    ''()  ,-. 0123456789:    ? abcdefghijklmnopqrstuvwxyz     ';
     end;
  1: begin
      OmegaBitmapFont1.OmegaImageIndex := 3;
      OmegaBitmapFont1.Characters:=' !"    ''()  ,-. 0123456789:    ? abcdefghijklmnopqrstuvwxyz     ';
     end;
  2: begin
      OmegaBitmapFont1.OmegaImageIndex := 4;
      OmegaBitmapFont1.Characters:=' !"    ''()  ,-. 0123456789:    ? abcdefghijklmnopqrstuvwxyz     ';
     end;
  3: begin
      OmegaBitmapFont1.OmegaImageIndex := 5;
      OmegaBitmapFont1.Characters:='abcdefghijklmnopqrstuvwxyz';
     end;
  4: begin
      OmegaBitmapFont1.OmegaImageIndex := 6;
      OmegaBitmapFont1.Characters:='         abcdefghijklmnopqrstuvwxyz';
     end;
  end;
 end;
end;

procedure TForm1.OmegaScreen1Init(Sender: TObject);
begin
// OmegaBitmapFont1.OmegaImageIndex := 2;
// OmegaBitmapFont1.Characters:=' !"    ''()  ,-. 0123456789:    ? abcdefghijklmnopqrstuvwxyz     ';
 OmegaBitmapFont2.MakeFont('Arial', DEFCHARACTERS, 12, D3DFONT_BOLD);
end;

end.



