unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OmegaScreen, OmegaTimer, ExtCtrls, OmegaImageList, OmegaBitmapFont,
  OmegaInput, OmegaUtils;

type
  TfrmMain = class(TForm)
    scr: TOmegaScreen;
    iml: TOmegaImageList;
    fnt16: TOmegaBitmapFont;
    tmr: TOmegaTimer;
    Inp: TOmegaInput;
    procedure FormCreate(Sender: TObject);
    procedure tmrTimer(Sender: TObject);
    procedure scrInit(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    x, y, r: Single;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
 self.ClientWidth := 800;
 self.ClientHeight := 600;
 scr.Width := self.ClientWidth;
 scr.Height := self.ClientHeight;
 scr.Init;
 inp.Initialize;
 scr.SetAntiAliasing(true);
 tmr.Enabled := True;
end;

procedure TfrmMain.tmrTimer(Sender: TObject);
begin
  inp.update;
  if oisbutton1 in inp.keyboard.statesclicked then scr.togglefullscreen;
  if not scr.CanDraw then exit;
  scr.BeginRender;
  scr.ClearScreen(0,0,0,0);

  //Rotation
  r := r + tmr.Delta * 90;
  if r >= 360 then r := r - 360;

  //Draw
  iml.BeginDraw;
  fnt16.ScaleX := 2;
  fnt16.ScaleY := 2;
  fnt16.PositionMode := pmTopLeft;
  fnt16.CharRotation := 0;
  fnt16.Rotation := 10;
  fnt16.Print(8, 32, 'FRAMES PER SECOND IS ' + inttostr(tmr.FPS));
  fnt16.Rotation := 15;
  fnt16.Print(8, 64, 'TESTING');
  fnt16.Rotation := 20;
  fnt16.Print(8, 96, 'PRESS SPACE FOR FULLSCREEN');
  fnt16.Rotation := r;
  fnt16.CharRotation := 0;
  fnt16.PositionMode := pmCenter;
  fnt16.ScaleY := 3;
  fnt16.Print(400, 450, 'OMEGA');
  fnt16.ScaleX := 3;
  fnt16.Rotation := 0;
  fnt16.CharRotation := r;
  fnt16.PositionMode := pmTopLeft;
  fnt16.Print(32, 300, 'OMEGA');
  iml.EndDraw;

  scr.EndRender;
end;

procedure TfrmMain.scrInit(Sender: TObject);
var r, g, b, a: byte;
begin
 GetPixel(iml.ImageList.items[0].image, 0, 0, r, g, b, a);
 SetTransparentColor(iml.ImageList.items[0].image, r, g, b);
 fnt16.characters := 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
 fnt16.OmegaImageIndex := 0;
end;

procedure TfrmMain.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key=27 then close;
end;

end.
