unit Unit1;

interface

uses
  Windows, Messages, SysUtils, {Variants, }Classes, Graphics, Controls, Forms,
  Dialogs, OmegaInput, DirectInput8, OmegaTimer, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer: TTimer;
    gbKeyboard: TGroupBox;
    lY: TLabel;
    lButton1: TLabel;
    lButton2: TLabel;
    gbMouse: TGroupBox;
    lMouseX: TLabel;
    lMouseY: TLabel;
    lMouseButton1: TLabel;
    lMouseButton2: TLabel;
    lMouseZ: TLabel;
    cbKeyboard: TCheckBox;
    cbMouse: TCheckBox;
    gbJoystick1: TGroupBox;
    cbJoystick1: TCheckBox;
    lX: TLabel;
    lJoystick1X: TLabel;
    lJoystick1Y: TLabel;
    lJoystick1Button1: TLabel;
    lJoystick1Button2: TLabel;
    lJoystick1Name: TLabel;
    gbJoystick2: TGroupBox;
    lJoystick2X: TLabel;
    lJoystick2Y: TLabel;
    lJoystick2Button1: TLabel;
    lJoystick2Button2: TLabel;
    lJoystick2Name: TLabel;
    cbJoystick2: TCheckBox;
    lJoystick1Caps: TLabel;
    lJoystick2Caps: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Input: TOmegaInput;
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure cbKeyboardClick(Sender: TObject);
    procedure cbMouseClick(Sender: TObject);
    procedure cbJoystick1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cbJoystick2Click(Sender: TObject);
  private
    { Private declarations }
    Procedure DisplayJoystickInfo;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Procedure TForm1.DisplayJoystickInfo;
begin
  lJoystick1Name.Caption := Input.Joystick.Name;
  lJoystick1Caps.Caption := 'Axes: '
                            + inttostr(Input.Joystick.AxesCount) + #13#10
                            + 'Buttons: '
                            + inttostr(Input.Joystick.ButtonCount) + #13#10
                            + 'Force Feedback: '
                            + BoolToStr(Input.Joystick.HasForceFeedback, true);

  if Input.JoystickCount > 1 then
  begin
    gbJoystick2.Enabled := true;
    lJoystick2Name.Caption := Input.Joysticks[1].Name;
    cbJoystick2.Checked := Input.Joysticks[1].Enabled;
    lJoystick2Caps.Caption := 'Axes: '
                              + inttostr(Input.Joysticks[1].AxesCount) + #13#10
                              + 'Buttons: '
                              + inttostr(Input.Joysticks[1].ButtonCount) + #13#10
                              + 'Force Feedback: '
                              + BoolToStr(Input.Joysticks[1].HasForceFeedback,
                                        true);
  end else
  begin
    gbJoystick2.Enabled := false;
    gbJoystick2.Font.Color := clGray;
    cbJoystick2.Caption := 'No 2nd Joystick present';
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  cbKeyboard.Checked := Input.Keyboard.Enabled;
  cbMouse.Checked := Input.Mouse.Enabled;
  cbJoystick1.Checked := Input.Joystick.Enabled;
  Timer.Enabled := true;
  DisplayJoystickInfo;
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
  Input.Update;

  //Keyboard States show Buttons pressed on the Keyboard

  if oisLeft in Input.Keyboard.States then lX.Caption := 'X: LEFT'
  else if oisRight in Input.Keyboard.States then lX.Caption := 'X: RIGHT'
  else lX.Caption := 'X:';
  if oisUp in Input.Keyboard.States then lY.Caption := 'Y: UP'
  else if oisDown in Input.Keyboard.States then lY.Caption := 'Y: DOWN'
  else ly.Caption := 'Y:';
  lButton1.Caption := 'Button1: ' + inttostr(integer(oisButton1 in Input.Keyboard.States));
  lButton2.Caption := 'Button2: ' + inttostr(integer(oisButton2 in Input.Keyboard.States));

  //The Mouse also has States to show very simple, whether the mouse is
  //left, right, up or down

  if oisLeft in Input.Mouse.States then lMouseX.Caption := 'X: LEFT'
  else if oisRight in Input.Mouse.States then lMouseX.Caption := 'X: RIGHT'
  else lMouseX.Caption := 'X:';
  if oisUp in Input.Mouse.States then lMouseY.Caption := 'Y: UP'
  else if oisDown in Input.Mouse.States then lMouseY.Caption := 'Y: DOWN'
  else lMouseY.Caption := 'Y:';

  //The Mouse supports up to 4 Buttons

  lMouseButton1.Caption := 'Button1: ' + inttostr(integer(oisButton1 in Input.Mouse.States));
  lMouseButton2.Caption := 'Button2: ' + inttostr(integer(oisButton2 in Input.Mouse.States));

  //The Mouse also has X, Y, and Z Values that show the Exact movement
  //of the mouse in those directions (Z is the Mousewheel)

  lMouseX.Caption := lMouseX.Caption + ' ' + inttostr(Input.Mouse.X);
  lMouseY.Caption := lMouseY.Caption + ' ' + inttostr(Input.Mouse.Y);
  lMouseZ.Caption := 'Z: ' + inttostr(Input.Mouse.Z);


  //The Joystick also has States to show very simple, whether the Joystick is
  //left, right, up or down

  if oisLeft in Input.Joystick.States then lJoystick1X.Caption := 'X: LEFT'
  else if oisRight in Input.Joystick.States then lJoystick1X.Caption := 'X: RIGHT'
  else lJoystick1X.Caption := 'X:';
  if oisUp in Input.Joystick.States then lJoystick1Y.Caption := 'Y: UP'
  else if oisDown in Input.Joystick.States then lJoystick1Y.Caption := 'Y: DOWN'
  else lJoystick1Y.Caption := 'Y:';

  //The Joystick supports up to 32 Buttons

  lJoystick1Button1.Caption := 'Button1: ' + inttostr(integer(oisButton1 in Input.Joystick.States));
  lJoystick1Button2.Caption := 'Button2: ' + inttostr(integer(oisButton2 in Input.Joystick.States));

  //The Joystick also has X, Y, and Z Values that show the Exact movement
  //of the Joystick in those directions

  lJoystick1X.Caption := lJoystick1X.Caption + ' ' + inttostr(Input.Joystick.X);
  lJoystick1Y.Caption := lJoystick1Y.Caption + ' ' + inttostr(Input.Joystick.Y);

  if Input.JoystickCount > 1 then
  begin

    if oisLeft in Input.Joysticks[1].States then lJoystick2X.Caption := 'X: LEFT'
    else if oisRight in Input.Joysticks[1].States then lJoystick2X.Caption := 'X: RIGHT'
    else lJoystick2X.Caption := 'X:';
    if oisUp in Input.Joysticks[1].States then lJoystick2Y.Caption := 'Y: UP'
    else if oisDown in Input.Joysticks[1].States then lJoystick2Y.Caption := 'Y: DOWN'
    else lJoystick2Y.Caption := 'Y:';

    lJoystick2Button1.Caption := 'Button1: ' + inttostr(integer(oisButton1 in Input.Joysticks[1].States));
    lJoystick2Button2.Caption := 'Button2: ' + inttostr(integer(oisButton2 in Input.Joysticks[1].States));

    lJoystick2X.Caption := lJoystick2X.Caption + ' ' + inttostr(Input.Joysticks[1].X);
    lJoystick2Y.Caption := lJoystick2Y.Caption + ' ' + inttostr(Input.Joysticks[1].Y);
  end;

end;

procedure TForm1.cbKeyboardClick(Sender: TObject);
begin
  Input.Keyboard.Enabled := cbKeyboard.Checked;
end;

procedure TForm1.cbMouseClick(Sender: TObject);
begin
  Input.Mouse.Enabled := cbMouse.Checked;
end;

procedure TForm1.cbJoystick1Click(Sender: TObject);
begin
  Input.Joystick.Enabled := cbJoystick1.Checked;
  DisplayJoystickInfo;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//  ShowMessage(keytostr((VKToDIK(key))));
end;

procedure TForm1.cbJoystick2Click(Sender: TObject);
begin
  if Input.JoystickCount > 1 then
  begin
    Input.Joysticks[1].Enabled := cbJoystick2.Checked;
    DisplayJoystickInfo;
  end;
end;

end.
