unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, OmegaMusic, OmegaScreen, OmegaFont;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ScrollBar3: TScrollBar;
    CheckBox1: TCheckBox;
    Music: TOmegaMusic;
    Label4: TLabel;
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ScrollBar3Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button4Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    // load the file to the first song item
    Music.Songs.Items[0].Load(openDialog1.FileName);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  // find 'song' and play it
  Music.Songs.Find('song').Play;
  Timer1.Enabled := True;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  // stop music
  Music.Songs.Items[0].Stop;
  Timer1.Enabled := False;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  // pause music (the sound continues to play when pause() is pressed again)
  Music.Songs.Items[0].Pause;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  // set Pan
  Music.Songs.Items[0].Pan := ScrollBar1.Position;
  Label1.Caption := 'Pan: ' + IntToStr(Music.Songs.Items[0].Pan);
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
  // set volume
  Music.Songs.Items[0].Volume := ScrollBar2.Position;
  Label2.Caption := 'Volume: ' + IntToStr(Music.Songs.Items[0].Volume);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  d1, d2: Double;
begin
  // find out how long the music is and how long it has played
  d1 := Music.Songs.Items[0].Position;
  d2 := Music.Songs.Items[0].Duration;

  // loop the sounds
  if CheckBox1.Checked then Music.Loop;

  // change the scrollbar position so that it shows us current sound position
  ScrollBar3.Position := Round(100 * (d1 / d2));
  Label3.Caption := FloatToStrf(d1,fffixed,2,2) + '/' +
   FloatToStrf(d2,fffixed,2,2);

  // stop the timer if the sound isn't playing
  if Music.Songs.Find('song').IsPlaying = false then Timer1.Enabled := False;
end;

procedure TForm1.ScrollBar3Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
var
  d1,d2: Double;
begin
  // set the correct position of the sound when the scrollbar is moved
  d2 := Music.Songs.Items[0].Duration;
  Music.Songs.Items[0].Position := (d2/100) * ScrollPos;
  d1 := Music.Songs.Items[0].Position;
  Label3.Caption := FloatToStrf(d1,fffixed,2,2) + '/' +
   FloatToStrf(d2,fffixed,2,2);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // init OmegaMusic, must be called before using OmegaMusic
  Music.Init;
end;

end.
