unit effect_frmHaupt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OmegaTimer, OmegaImageList, OmegaSprite, OmegaScreen, contnrs,
  OmegaBitmapFont, ExtCtrls;

type
  TfrmHaupt = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaSprite1: TOmegaSprite;
    OmegaImageList1: TOmegaImageList;
    OmegaTimer1: TOmegaTimer;
    OmegaBitmapFont1: TOmegaBitmapFont;
    procedure FormShow(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OmegaScreen1Init(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  public
    procedure CreateEnergy(intX, intY : Integer);
  end;

const intMaxPartikel = 3000;
var
  frmHaupt: TfrmHaupt;
  EnergyList: TObjectList;
  EnergyListA: array[0..intMaxPartikel] of TSprite;
  intRadius : Integer = 40;
  nump: integer = 250;
  speed : integer = 10; // range 0..100
implementation

{$R *.DFM}

procedure TfrmHaupt.CreateEnergy(intX, intY : Integer);
var intDummy : Integer;
begin
  for intDummy := 1 to nump do
  begin
   with EnergyListA[intDummy] do
   begin
      if random(100)<speed then
      begin
       X := intX + random(intRadius) - random(intRadius);
       Y := intY + random(intRadius) - random(intRadius);
       Alpha := 125;
      end else
       if Alpha > 5 then Alpha := Alpha - 5;
      Image := OmegaImageList1.ImageList.Items[0];
      Rotation := Random(360);
      Red := 255;
      Green := 255;
      Blue := 255;
      Width := 8;
      Height := 25;
      DoAdditiveBlend := true;
   end;
  end;
end;

procedure TfrmHaupt.FormShow(Sender: TObject);
var i:integer;
begin
 for i := 1 to intmaxpartikel do EnergyListA[i] := TSprite.Create(OmegaSprite1);
 Cursor := crHandPoint;
 OmegaTimer1.Enabled := True;
end;

procedure TfrmHaupt.OmegaTimer1Timer(Sender: TObject);
var intDummy : Integer;
    p: TPoint;
begin
  if not OmegaScreen1.CanDraw then exit;
  
  OmegaScreen1.BeginRender;
  OmegaScreen1.ClearScreen(0,0,0,255);

  if not OmegaScreen1.FullScreen then
  begin
   p := ScreenToClient(Mouse.CursorPos);
   CreateEnergy(p.x - 2, p.Y - 20);
  end else
   CreateEnergy(Mouse.CursorPos.X - 2, Mouse.CursorPos.Y - 20);

  for intDummy := 1 to nump do EnergyListA[intDummy].Draw;

  OmegaBitmapFont1.Print(2,2,'FPS: '+inttostr(round(OmegaTimer1.fps)));
  OmegaBitmapFont1.Print(2,16,'Partikel: '+inttostr(nump));

  OmegaScreen1.EndRender;
end;

procedure TfrmHaupt.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key = 27 then close;
 if key = 32 then OmegaScreen1.ToggleFullScreen;
end;

procedure TfrmHaupt.OmegaScreen1Init(Sender: TObject);
begin
 OmegaBitmapFont1.MakeFont('Verdana', DEFCHARACTERS, 10, 0);
end;

procedure TfrmHaupt.FormCreate(Sender: TObject);
begin
 self.ClientWidth := 800;
 self.ClientHeight := 600;
 OmegaScreen1.Width := self.ClientWidth;
 OmegaScreen1.Height := self.ClientHeight;
 OmegaScreen1.Init;
end;

end.
