unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OmegaTimer, OmegaSprite, OmegaFont, OmegaImageList, OmegaScreen,
  OmegaParticleEngine, ExtCtrls, StdCtrls;

type

  TMouseParticle = class(TParticle)
  public
    procedure Update(MoveCount: Single); override;
    procedure Reset; override;
  end;

type
  TForm1 = class(TForm)
    OmegaScreen: TOmegaScreen;
    OmegaImageList: TOmegaImageList;
    OmegaSprite: TOmegaSprite;
    OmegaTimer: TOmegaTimer;
    OmegaParticleEngine: TOmegaParticleEngine;
    Timer1: TTimer;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OmegaTimerTimer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  

implementation

{$R *.dfm}

procedure TMouseParticle.Update;
begin
  inherited Update(MoveCount);
  Z := Z + 1;
end;

procedure TMouseParticle.Reset;
begin
  inherited Reset;
  Xvel := (Random(1000)-500)/100;
  Yvel := (Random(1000)-500)/100;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  self.ClientWidth := 640;
  self.ClientHeight := 480;
  OmegaScreen.Width := self.ClientWidth;
  OmegaScreen.Height := self.ClientHeight;
  OmegaScreen.Init;
  OmegaImageList.ImageList.LoadFromFile('images.oil');
  OmegaImageList.Init;   
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  with OmegaParticleEngine.EngineList.Items[0] do
  begin
    NumOfParticles := 0;
    UseCustomParticle(TMouseParticle);
    Sprite.Image := OmegaImageList.ImageList.Items[0];
    Sprite.ImageIndex := 0;
    Particle.Decay := 1;
    Particle.LifeTime := 50;
    Particle.RandomLocation := False;
    Particle.Animate := True;
    Particle.AnimateCount := 21;
    Particle.AnimateIndex := 0;
    Particle.Loop := False;
    Particle.RepeatCount := 0;
    Particle.Z := 500;
//    Particle.UpdateSpeed := 0.25;
  end;
  with OmegaParticleEngine.EngineList.Items[1] do
  begin
    NumOfParticles := 0;
    Sprite.Image := OmegaImageList.ImageList.Items[1];
    Sprite.ImageIndex := 0;
    Particle.Decay := 1;
    Particle.LifeTime := 50;
    Particle.RandomLocation := False;
    Particle.Animate := True;
    Particle.AnimateCount := 20;
    Particle.AnimateIndex := 0;
    Particle.Loop := False;
    Particle.RepeatCount := 0;
    Particle.Z := 500;
//    Particle.UpdateSpeed := 0.10;
  end;
  OmegaParticleEngine.Init;
  OmegaTimer.Enabled := True;
end;

procedure TForm1.OmegaTimerTimer(Sender: TObject);
begin
  if not OmegaScreen.CanDraw then Exit;

  OmegaScreen.BeginRender;
  OmegaImageList.BeginDraw;
  OmegaScreen.ClearScreen(0,0,0,0);

  OmegaSprite.Move(0);
  OmegaSprite.Draw;
  OmegaSprite.Dead;


  OmegaParticleEngine.EngineList.Items[0].Update(0.25);
  OmegaParticleEngine.EngineList.Items[1].Update(0.1);

  OmegaImageList.EndDraw;
  OmegaScreen.EndRender;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  with OmegaParticleEngine.EngineList.Items[0] do
  begin
    Particle.X := width div 2;
    Particle.Y := height div 2;
    Clear;
    NumOfParticles := 300;
  end;
  with OmegaParticleEngine.EngineList.Items[1] do
  begin
    Particle.X := width div 2 - 100;
    Particle.Y := height div 2 - 100;
    Clear;
    NumOfParticles := 1;
  end;
end;

end.
