unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OmegaImageList, OmegaScreen, OmegaTimer,
  OmegaBitmapFont, OmegaSprite, OmegaPrimitives,
  OmegaInput, OmegaRenderer;

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaTimer1: TOmegaTimer;
    OmegaBitmapFont1: TOmegaBitmapFont;
    OmegaPrimitives1: TOmegaPrimitives;
    inp: TOmegaInput;
    procedure FormCreate(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  end;

var Form1: TForm1;
    angle: single;
    dofill: boolean;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 self.ClientWidth := 800;
 self.ClientHeight := 600;
 OmegaScreen1.Width := self.ClientWidth;
 OmegaScreen1.Height := self.ClientHeight;
 OmegaScreen1.Init;
 dofill := true;
 OmegaTimer1.Enabled := True;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var x, y: integer;
    s, s2, c, c2,  // sine and cosine variables
    t, t2: single; // temporary variables
    v: array[0..5] of tpoint;
begin
 inp.update;
 if oisbutton1 in inp.keyboard.statesclicked then
  OmegaScreen1.ToggleFullScreen;

 if not OmegaScreen1.CanDraw then exit;
 OmegaScreen1.BeginRender;
 OmegaScreen1.Device.SetVertexShader(OmegaVertexDef);
 OmegaScreen1.ClearScreen(0, 0, 0, 0);

 angle := angle + 0.5;
 if angle >= 360 then angle := angle - 360;
 s := sin(angle * pi / 180);
 s2 := sin(pi + (4 * angle * pi / 180));
 c := cos(angle * pi / 180);
 c2 := cos(pi + (4 * angle * pi / 180));

 // draw background
 for x := 0 to 2 do
  for y := 0 to 1 do
   OmegaImageList1.ImageList.Items[1].Draw(
   x*256, y*256, 0, 0, 0, 1, 1,
    OmegaColor(255, 255, 255, 255), -1);

  t := 50 * (s2 + 1);
  t2 := 50 + 100 * (s + 1);

  with OmegaPrimitives1 do
  begin
   Filled := dofill;
   Quadrangle4Col(round(t), 50,
    300 + round(t) * 5, 90, 400 + round(t)*2,
    round(t) + 300, 90, 400,
    OmegaColor(255, 0, 0, round(t2)),
    OmegaColor(0, 0, 255, round(t2)),
    OmegaColor(0, 255, 0, round(t2)),
    OmegaColor(255, 255, 255, round(t2)));
   Line2Col(0, 0, 4 * round(t2), 4 * round(t), OmegaColor($FFFFFFFF),
    OmegaColor($FF000000));
   Arc(100, 400, 100, 32, t2, OmegaColor($9FFFFF00), false);
   Circle(500, 400, 100, 5, OmegaColor(round(t), 255, 0, 255 - round(t2)));
   Ellipse(400, 200, 50, 25, OmegaColor($AF0000FF));
   Triangle(200, 200, 300, 50, 250, 300, OmegaColor($FF000000));
   v[0].x := 100; v[0].y := 100;
   v[1].x := 100; v[1].y := 50;
   v[2].x := 300; v[2].y := 50;
   v[3].x := 350; v[3].y := 250;
   v[4].x := 100; v[4].y := 250;
   v[5].x := 50; v[5].y := 100;
   Polygon(v, OmegaColor($6FFFFFFF));
  for x := 0 to 500 do
   Point(100 + random(100), 100 + random(100),
    OmegaColor(random(255), random(255), random(255), 255));
 end;

 OmegaBitmapFont1.Print(260, 460, 'Press "F" to switch filling on/off');
 OmegaBitmapFont1.Print(260, 480, 'Press "space" to toggle fullscreen');

 OmegaScreen1.EndRender;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 OmegaTimer1.Enabled := False;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key = 27 then close;
 if key = ord('F') then dofill := not dofill;
end;

end.



