unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, OmegaImageList, OmegaScreen, OmegaTimer,
  OmegaBitmapFont, OmegaRenderer, OmegaUtils, OmegaSprite,
  OmegaInput;

type
  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaTimer1: TOmegaTimer;
    OmegaSprite1: TOmegaSprite;
    OmegaBitmapFont1: TOmegaBitmapFont;
    OmegaInput1: TOmegaInput;
    procedure FormCreate(Sender: TObject);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  end;

var
  Form1: TForm1;
  Angle: single;
  CurWid, CurHei,
  CurWid2, CurHei2,
  CurSpr: Integer;
  blendmode2, blendmode,
  mirror_mode, antialias_mode: integer;
  mv, mh, showgray, showspot: boolean;
  bstr, istr, mstr: string;

  implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 self.ClientWidth := 800;
 self.ClientHeight := 600;
 OmegaScreen1.Width := self.ClientWidth;
 OmegaScreen1.Height := self.ClientHeight;
 OmegaScreen1.Init;
 CurSpr := 0; // current sprite number (used for grayscale switching)
 // store width and height of current sprite:
 CurWid := OmegaImageList1.ImageList.Items[CurSpr].ImageWidth;
 CurHei := OmegaImageList1.ImageList.Items[CurSpr].ImageHeight;
 // store half width and height of current sprite
 CurWid2 := CurWid div 2;
 CurHei2 := CurHei div 2;

 Angle := 0;
 mirror_mode := 0;
 blendmode := bmNormal;
 blendmode2 := bmSrcAdd;
 mv := false;
 mh := false;
 antialias_mode := 1;
 istr := 'on';
 mstr := 'none';
 bstr := 'bmNormal';
 showspot := true;
 showgray := false;
 OmegaTimer1.Enabled := True;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var x, y: integer;
    s, c, s2, c2,   // sine and cosine variables
    t1, t2, t3, t4, t5: single; // temporary variables
begin
 if oisbutton1 in OmegaInput1.keyboard.statesclicked then
  OmegaScreen1.ToggleFullScreen;
 if not OmegaScreen1.CanDraw then exit;
 OmegaInput1.Update;
 OmegaScreen1.BeginRender;
 OmegaScreen1.ClearScreen(0, 0, 0, 255);

 angle := angle + 0.6;
 if angle >= 360 then angle := angle - 360;
 s := sin(angle * pi / 180);
 c := cos(angle * pi / 180);
 s2 := sin(pi + (2 * angle * pi / 180));
 c2 := cos(pi + (2 * angle * pi / 180));

 // draw background
 for x := 0 to 2 do
  for y := 0 to 1 do
   OmegaImageList1.ImageList.Items[3].Draw(
   x * 256, y * 256, 0, 0, 0, 1, 1,
    OmegaColor(255, 255, 255, 255), mv, mh, -1);

   OmegaScreen1.SetAntiAliasing(false);
   OmegaBitmapFont1.Print(50, 220, 'rotate + scale + alpha');
   OmegaBitmapFont1.Print(300, 220,'stretch + global color');
   OmegaBitmapFont1.Print(560, 220,'dynamic vertex lights');
   OmegaBitmapFont1.Print(50, 475, 'dynamic vertex colors');
   OmegaBitmapFont1.Print(320, 475,'vertex deform');
   OmegaBitmapFont1.Print(560, 475,'dynamic alpha blend');
   OmegaBitmapFont1.Print(20, 545, 'antialias: ' + istr);
   OmegaBitmapFont1.Print(20, 565, 'mirror: ' + mstr);
   OmegaBitmapFont1.Print(290, 525,'"g" for grayscale sprites');
   OmegaBitmapFont1.Print(290, 545,'"m" for mirror change');
   OmegaBitmapFont1.Print(290, 565,'"b", "n" for blendmode change');
   OmegaBitmapFont1.Print(560, 525,'"s" for spotlight on/off');
   OmegaBitmapFont1.Print(560, 545,'"a" for antialias on/off');
   OmegaBitmapFont1.Print(560, 565,'"space" to toggle fullscreen');
   OmegaBitmapFont1.Print(20, 20,'FPS: ' + IntToStr(OmegaTimer1.FPS));
   OmegaBitmapFont1.Print(20, 525, 'blendmode: '+bstr);
   OmegaScreen1.SetAntiAliasing(antialias_mode = 1);

 // box 1: rotated and scaled
 t1 := 360 * abs(s); // rotation movement
 t2 := s + 1.5;  // scaling movement
 t3 := 127 * (c + 1);
 OmegaImageList1.ImageList.Items[CurSpr].Draw(
  128 - CurWid2, 128 - CurHei2, // position
  t1, 0.5, 0.5, // rotation angle and center
  t2, t2, // scaling
  OmegaColor(255, 255, 255, round(t3)), mv, mh, -1, blendmode);

 // box 2: rotated with global coloring
 t1 := 180 * (c + 1); // rotation movement
 t2 := 100 + 155 * abs(s);  // color movement
 t3 := 100 + 155 * abs(c2);  // color movement
 t4 := 100 + 155 * abs(c);  // color movement
 t5 := (c + 1); // rotation movement
 OmegaImageList1.ImageList.Items[CurSpr].Draw(
  384 - CurWid2, 128 - CurHei2, // position
  t1, 0.5, 0.5, // rotation angle and center
  1 + t5, 2, // scaling
  OmegaColor(round(t2), round(t3), round(t4), 255),
  mv, mh, -1, blendmode);

 // box 3: dynamic lightning
 if (angle >= 0) and (angle < 90) then
 begin
  t2 := 64 + (1 - (angle / 90)) * 191;
  t3 := 64 + (angle / 90) * 191;
  t4 := 64;
  t5 := 64;
 end else
 if (angle >= 90) and (angle <= 180) then
 begin
  t3 := 64 + (1 - ((angle - 90) / 90)) * 191;
  t4 := 64 + ((angle - 90) / 90) * 191;
  t2 := 64;
  t5 := 64;
 end else
 if (angle >= 180) and (angle <= 270) then
 begin
  t4 := 64 + (1 - ((angle - 180) / 90)) * 191;
  t5 := 64 + ((angle - 180) / 90) * 191;
  t2 := 64;
  t3 := 64;
 end else
 begin
  t5 := 64 + (1 - ((angle - 270) / 90)) * 191;
  t2 := 64 + ((angle - 270) / 90) * 191;
  t4 := 64;
  t3 := 64;
 end;
 OmegaImageList1.ImageList.Items[CurSpr].Draw4Col(
  640 - CurWid2, 128 - CurHei2, // position
  0, 0.5, 0.5, // rotation angle and center
  2, 2, // scaling
   OmegaColor(round(t2), round(t2), round(t2), 255),
   OmegaColor(round(t3), round(t3), round(t3), 255),
   OmegaColor(round(t4), round(t4), round(t4), 255),
   OmegaColor(round(t5), round(t5), round(t5), 255),
   mv, mh, -1, blendmode);

 // box 4: vertex coloring
 t1 := 180 * (s + 1); // rotation movement
 t2 := 100 * (c + 1.5);  // color movement
 t3 := 100 * (s2 + 1.5);  // color movement
 t4 := 255 * abs(c);  // color movement
 t5 := 100 * (c + 1.5);  // color movement
 OmegaImageList1.ImageList.Items[CurSpr].Draw4Col(
  128 - CurWid2, 384 - CurHei2, // position
  t1, 0.5, 0.5, // rotation angle and center
  2, 2, // scaling
  OmegaColor(round(t3), round(t3), 255 - round(t5), 255),
  OmegaColor(round(t2), round(t4), round(t5), 255),
  OmegaColor(round(t2), round(t4), round(t5), 255),
  OmegaColor(round(t3), 255 - round(t3), 255 - round(t5), 255),
  mv, mh, -1, blendmode);

 // box 5: vertex deform
 OmegaImageList1.ImageList.Items[CurSpr].Draw4Col(
  384 - CurWid2, 384 - CurHei,
  384 + CurWid2 + round(CurWid * (s + 1)), 384 - CurHei,
  384 + CurWid2, 384 + CurHei,
  384 - CurWid2 - round(CurWid * (s + 1)), 384 + round(CurHei * (s + 1)),
  0, 0, 0, 1, 1,
  OmegaWhite, OmegaWhite,
  OmegaWhite, OmegaWhite, mv, mh, -1, blendmode);

 // box 6: partial alpha blend
 t1 := 180 * (c + 1); // rotation movement
 t2 := 127 * abs(s2 + 1);  // alpha movement
 OmegaImageList1.ImageList.Items[CurSpr].Draw4Col(
  640 - CurWid2, 384 - CurHei2, // position
  t1, 0.5, 0.5, // rotation angle and center
  1.5, 1.5, // scaling
  OmegaColor(255, 255, 255, round(t2)),
  OmegaColor(255, 255, 255, round(t2)),
  OmegaColor(255, 255, 255, 255 - round(t2)),
  OmegaColor(255, 255, 255, 255 - round(t2)),
  mv, mh, -1, blendmode);

 if showspot then
 begin
  // draw spotlight
  t1 := 300 + 300 * s;
  t2 := 100 + 100 * c2;
  t3 := 100 * (s2 + 1.5);  // color movement
  t4 := 100 * (c + 1.5);   // color movement
  t5 := 120 * (s2 + 1.5);  // color movement
 OmegaImageList1.ImageList.Items[2].Draw(
   round(t1), round(t2), // position
   0, 0.5, 0.5, // rotation angle and center
   (t1 + t5) / 150, t5 / 70, // scaling
   OmegaColor(round(t3), round(t4), 255 - round(t3), 255), -1, blendmode2);
 end;
 OmegaScreen1.EndRender;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 OmegaTimer1.Enabled := False;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key = 27 then close;
 if key = ord('G') then
 begin
  showgray := not showgray;
  if showgray then CurSpr := 1
  else CurSpr := 0;
 end;
 if key=ord('M') then
 begin
  mirror_mode := (mirror_mode + 1) mod 4;
  if OmegaScreen1.CanDraw then 
  case mirror_mode of
  0:begin
   mh := false;
   mv := false;
   mstr := 'none';
  end;
  1:begin
   mh := false;
   mv := true;
   mstr := 'vertically';
  end;
  2:begin
   mh := true;
   mv := false;
   mstr := 'horizontally';
  end;
  3:begin
   mh := true;
   mv := true;
   mstr := 'both';
  end;
  else
  end;
 end;

 if key = ord('S') then showspot := not showspot;
 if key = ord('N') then
  blendmode2 := (blendmode2 + 1) mod 14;
 if key = ord('B') then
 begin
  blendmode := (blendmode + 1) mod 14;
  case blendmode of
  0: bstr := 'bmNormal';
  1: bstr := 'bmAdd';
  2: bstr := 'bmSrcAdd';
  3: bstr := 'bmSrcCol';
  4: bstr := 'bmSrcColAdd';
  5: bstr := 'bmMultiply';
  6: bstr := 'bmMultiplyAlpha';
  7: bstr := 'bmInvMultiply';
  8: bstr := 'bmInvMultiplyAlpha';
  9: bstr := 'bmInvert';
  10: bstr := 'bmSrcBright';
  11: bstr := 'bmDestBright';
  12: bstr := 'bmInvSrcBright';
  13: bstr := 'bmInvDestBright';
  end;
 end;
 if key = ord('A') then
 begin
  antialias_mode := 1 - antialias_mode;
  if antialias_mode = 0 then istr := 'off'
  else istr := 'on';
 end;
end;

end.



