unit OmegaSurface;

interface

uses
  Windows, Messages, SysUtils, Classes, D3DX8,
  Forms, dialogs, OmegaScreen, {$I UseD3D8.inc};

type
  TOmegaSurface = class(TComponent)
  protected

  private
    FhWnd_old, FhWnd: hWnd;
    tr: TRect;
    FWidth_old, FHeight_old, FX, FY, FWidth, FHeight: LongInt;
    procedure SetX(const Value: LongInt);
    procedure SetY(const Value: LongInt);
    procedure SetWidth(value: LongInt);
    procedure SetHeight(value: LongInt);
    procedure SetOmegaScreen(const Value: TOmegaScreen);
  protected
    FOmegaScreen: TOmegaScreen;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    procedure SethWnd(value: hWnd);
    procedure BeginRender;
    procedure EndRender;
  published
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
    property X: LongInt read FX write SetX;
    property Y: LongInt read FY write SetY;
    property Width: LongInt read FWidth write SetWidth;
    property Height: LongInt read FHeight write SetHeight;
    property OmegaScreen: TOmegaScreen read FOmegaScreen write SetOmegaScreen;
  end;

implementation

constructor TOmegaSurface.Create(AOwner: TComponent);
begin
 inherited;
 SetWidth(100);
 SetHeight(100);
 SetX(0);
 SetY(0);
 SethWnd(0);
end;

destructor TOmegaSurface.Destroy;
begin
 inherited Destroy;
end;

procedure TOmegaSurface.SethWnd(value: hWnd);
begin
 FhWnd := value;
end;

procedure TOmegaSurface.SetWidth(value: LongInt);
begin
 FWidth := value;
end;

procedure TOmegaSurface.SetHeight(value: LongInt);
begin
 FHeight := value;
end;

procedure TOmegaSurface.SetX(const Value: LongInt);
begin
 FX := Value;
end;

procedure TOmegaSurface.SetY(const Value: LongInt);
begin
 FY := Value;
end;

procedure TOmegaSurface.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
 inherited;
 case Operation of
  opInsert: if (AComponent is TOmegaScreen)and(not Assigned(OmegaScreen)) then
   SetOmegaScreen(TOmegaScreen(AComponent));
  opRemove: if (AComponent = OmegaScreen) then OmegaScreen:= nil;
 end;
end;

procedure TOmegaSurface.SetOmegaScreen(const Value: TOmegaScreen);
begin
 FOmegaScreen := Value;
end;

function imax(i1, i2: integer): integer;
begin
 if i1 > i2 then result := i1 else result := i2;
end;

function imin(i1, i2: integer): integer;
begin
 if i1 > i2 then result := i2 else result := i1;
end;

procedure TOmegaSurface.BeginRender;
begin
 FhWnd_old := FOmegaScreen.ThehWnd;
 if FhWnd_old <> FhWnd then
 begin
  if FOmegaScreen.Rendering then FOmegaScreen.EndRender;
  FOmegaScreen.SethWnd(FhWnd);
  FOmegaScreen.Device.BeginScene;
  FWidth_old := FOmegaScreen.Width;
  FHeight_old := FOmegaScreen.Height;
  FOmegaScreen.Width := FWidth;
  FOmegaScreen.Height := FHeight;
 end else
 begin
  tr := FOmegaScreen.GetViewPort;
  FOmegaScreen.SetViewPort(
   imax(FX, 0), imax(FY, 0), imin(FX + FWidth, FOmegaScreen.Width),
   imin(FY + FHeight, FOmegaScreen.Height));
 end;
end;

procedure TOmegaSurface.EndRender;
var pr, pr2: TRect;
begin
 if FhWnd_old <> FhWnd then
 begin
  pr := rect(0, 0, FWidth, FHeight);
  GetClientRect(FhWnd, pr2);
  FOmegaScreen.Device.Present(@pr, @pr2, FhWnd, nil);
  FOmegaScreen.Device.EndScene;
  FOmegaScreen.SethWnd(FhWnd_old);
  FOmegaScreen.Width := FWidth_old;
  FOmegaScreen.Height := FHeight_old;
  if FOmegaScreen.Rendering then FOmegaScreen.Rendering := false;
 end else
  FOmegaScreen.SetViewPort(tr);
end;

end.
