unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  ExtCtrls, StdCtrls, ComCtrls, Dialogs;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Panel1: TPanel;
    Label1: TLabel;
    CBSize: TComboBox;
    BUCopy: TButton;
    TrackBar1: TTrackBar;
    Label2: TLabel;
    CBInvert: TCheckBox;
    TrackBar2: TTrackBar;
    ColorBox: TColorDialog;
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    Button2: TButton;
    procedure CBSizeChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure BUCopyClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure CBInvertClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  public
    bmp : TBitmap;
    procedure DrawBmp;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Clipbrd;

procedure TForm1.DrawBmp;
var
   x, y, d, h, h2, bgColor : Integer;
   ih2, f, fy, r, f2, fy2, r2, fmax : Single;
   scanLine1, scanLine2 : PByteArray;
   invert : Boolean;
begin
   bmp.Width:=PaintBox1.Width;
   h:=bmp.Width;
   bmp.Height:=h;
   h2:=h div 2;
   ih2:=1/h2;
   r:=Sqr(TrackBar1.Position/30);
   r2:=Sqr(TrackBar2.Position/30);
   fmax:=0;
   for x:=0 to 999 do begin
      f:=x/1000;
      f:=exp(r*ln(f+0.0001)) * exp(r2*ln(0.9999-f));
      if f>fmax then fmax:=f;
   end;
   fmax:=0.99/fmax;
   invert:=CBInvert.Checked;
   bgColor:=ColorToRGB(ColorBox.Color);
   bgColor:=RGB(GetBValue(bgColor), GetGValue(bgColor), GetRValue(bgColor));
   for y:=0 to h2-1 do begin
      fy:=Sqr((y+0.5-h2)*ih2);
      scanLine1:=bmp.ScanLine[y];
      scanLine2:=bmp.ScanLine[h-1-y];
      for x:=0 to h2-1 do begin
         f:=Sqr((x+0.5-h2)*ih2)+fy;
         if f<1 then begin
            f:=exp(r*ln(f)) * exp(r2*ln(1-f)) * fmax;
            d:=Trunc(f*256);
         end else d:=-1;
         if d<0 then
            d:=bgColor
         else begin
            if invert then d:=255-d;
            d:=d+(d shl 8)+(d shl 16);
         end;
         PInteger(@scanLine1[x*4])^:=d;
         PInteger(@scanLine2[x*4])^:=d;
         PInteger(@scanLine1[(h-1-x)*4])^:=d;
         PInteger(@scanLine2[(h-1-x)*4])^:=d;
      end;
   end;
end;

procedure TForm1.CBSizeChange(Sender: TObject);
begin
   PaintBox1.Width:=StrToInt(CBSize.Text);
   PaintBox1.Height:=PaintBox1.Width;
   DrawBmp;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 CBSize.ItemIndex:=2;
 bmp:=TBitmap.Create;
 bmp.PixelFormat:=pf32bit;
 DrawBmp;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   bmp.Free;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
   PaintBox1.Canvas.Draw(0, 0, bmp);
end;

procedure TForm1.BUCopyClick(Sender: TObject);
begin
 if savedialog1.execute then
  bmp.SaveToFile(savedialog1.filename);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
   DrawBmp;
   PaintBox1Paint(Self);
end;

procedure TForm1.CBInvertClick(Sender: TObject);
begin
   DrawBmp;
   PaintBox1Paint(Self);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 colorbox.execute;
 DrawBmp;
 PaintBox1Paint(Self);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Clipboard.Assign(bmp);
end;

end.
