{

   Changes 0.4 Ralph Wesseling
 - Transparancy added. Hold cursor over bitmap area with transparant colour and click down.
 - Move items in the list (up and down)
 - Stretch images that are too wide (scrollbar)
 - Remember encryption code
 - Increase size of display window
 - Removed bugs
 
   Changes 0.5 Ralph Wesseling
 - Changes to interface
 - Removed bugs
 - Animation of image now possible
 - Improved stability

}


unit ImagelistEditorUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, inifiles, mmsystem,
  Dialogs, OmegaImageList, StdCtrls, ExtCtrls, ExtDlgs, pngimage, jpeg, math,
  OmegaScreen, Buttons, Menus, ComCtrls, ImgList, OmegaTimer, ToolWin;

const C1 = 52845;
      C2 = 22719;


type
  TForm1 = class(TForm)
    lst_Images: TListBox;
    OmegaImagelist: TOmegaImageList;
    OpenPictureDialog: TOpenPictureDialog;
    SpeedMovePictureUp: TSpeedButton;
    SpeedMovePictureDown: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    templist: TOmegaImageList;
    ColorDialog1: TColorDialog;
    ScrollBoxDisplay: TScrollBox;
    lbl_filename: TLabel;
    Image: TImage;
    SavePictureDialog1: TSavePictureDialog;
    OpenPictureDialog1: TOpenPictureDialog;
    Timer1: TTimer;
    Button4: TButton;
    Label9: TLabel;
    PanelGlobalCol: TPanel;
    PanelInfo: TPanel;
    LabelImgName: TLabel;
    txt_Name: TEdit;
    Label5: TLabel;
    Label2: TLabel;
    txt_Width: TEdit;
    Tileheight: TLabel;
    txt_Height: TEdit;
    chb_trans: TCheckBox;
    Label1by: TLabel;
    StatusBar1: TStatusBar;
    ImageList1: TImageList;
    Panel1: TPanel;
    OmegaScreen1: TOmegaScreen;
    OmegaTimer1: TOmegaTimer;
    BitBtn1: TBitBtn;
    LabelCurCel: TLabel;
    Bevel2: TBevel;
    Label3: TLabel;
    PanelTransCol: TPanel;
    TrackBarAnimate: TTrackBar;
    LabelSpeed: TLabel;
    PanelMouseOverCol: TPanel;
    ToolBar1: TToolBar;
    ToolbarQuitButton: TToolButton;
    ToolButton2: TToolButton;
    ToolbarNewImageList: TToolButton;
    ToolButton1: TToolButton;
    OpenImagelist: TToolButton;
    SaveImageList: TToolButton;
    ToolButton3: TToolButton;
    ToolButtonKey: TToolButton;
    ToolButtonOpenEncrypt: TToolButton;
    ToolButtonSaveEncrypt: TToolButton;
    ToolButton7: TToolButton;
    ToolButtonAddImage: TToolButton;
    ToolButtonExportImage: TToolButton;
    ToolButton10: TToolButton;
    ToolButtonDeleteImage: TToolButton;
    ToolButtonAbout: TToolButton;
    ToolButton13: TToolButton;
    EditTileWidth: TEdit;
    ButtonGlobWidth: TButton;
    ButtonSetGlobalTileHeigth: TButton;
    EditTileHeight: TEdit;
    Label1: TLabel;
    Bevel1: TBevel;
    Bevel3: TBevel;
    procedure btn_addClick(Sender: TObject);
    procedure btn_loadClick(Sender: TObject);
    procedure lst_ImagesClick(Sender: TObject);
    procedure btn_saveClick(Sender: TObject);
    procedure SpeedMovePictureUpClick(Sender: TObject);
    procedure txt_NameExit(Sender: TObject);
    procedure txt_WidthExit(Sender: TObject);
    procedure txt_HeightExit(Sender: TObject);
    procedure chb_transClick(Sender: TObject);
    procedure PanelTransColClick(Sender: TObject);
    procedure txt_OVWidthExit(Sender: TObject);
    procedure chb_overrideClick(Sender: TObject);
    procedure btn_delClick(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure SaveImagelist1Click(Sender: TObject);
    procedure AddImage1Click(Sender: TObject);
    procedure DeleteImage1Click(Sender: TObject);
    procedure NewImagelist1Click(Sender: TObject);
    procedure btn_newClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure OpenDialog1Show(Sender: TObject);
    procedure btn_ChangeClick(Sender: TObject);
    procedure ChangeImage1Click(Sender: TObject);
    procedure SaveImage1Click(Sender: TObject);
    procedure LoadcryptedImagelist1Click(Sender: TObject);
    procedure SavecryptedImagelist1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ButtonAddImageClick(Sender: TObject);
    procedure PanelGlobalColClick(Sender: TObject);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RememberEncryption1Click(Sender: TObject);
    procedure Enterencryptioncode1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure txt_HeightKeyPress(Sender: TObject; var Key: Char);
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure SpeedButtonStartClick(Sender: TObject);
    procedure TrackBarAnimateChange(Sender: TObject);
    procedure ButtonGlobWidthClick(Sender: TObject);
    procedure ButtonSetGlobalTileHeigthClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Function  WriteIntegerToConfigFile(Section, Value : string; DefaultValue : Integer) : boolean;
    Function  ReadIntegerFromConfigIni(Section, Value : string; DefaultValue : Integer) : integer;
    procedure fill_lst;
    procedure fill_edits;
    procedure clear;
    procedure EnterEncryptionCode;

  public
    Anim   : Cardinal;
    CurCel : integer;
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  password: short;

implementation

uses Info;

{$R *.dfm}

procedure TForm1.btn_addClick(Sender: TObject);
var picture: tpicture;
begin
  with openpicturedialog do begin
    title:='Load image';
    if execute then image.Picture.LoadFromFile(openpicturedialog.FileName);
    OmegaImagelist.ImageList.Add;
    lst_Images.Items.AddObject(extractfilename(openpicturedialog.FileName),image);
    picture:=tpicture.Create;
    picture.LoadFromFile(filename);
    OmegaImagelist.ImageList.Items[OmegaImagelist.ImageList.Count-1].SetPicture(picture);
    OmegaImagelist.ImageList.Items[OmegaImagelist.ImageList.Count-1].Name:=extractfilename(filename);
    OmegaImagelist.ImageList.items[OmegaImagelist.imagelist.count-1].DisplayName := extractfilename(filename);
    OmegaImagelist.ImageList.Items[OmegaImagelist.ImageList.Count-1].TileHeight:=picture.Height;
    OmegaImagelist.ImageList.Items[OmegaImagelist.ImageList.Count-1].Tilewidth:=picture.Width;
    OmegaImagelist.ImageList.Items[OmegaImagelist.ImageList.Count-1].Transparent:=true;
    OmegaImagelist.ImageList.Items[OmegaImagelist.ImageList.Count-1].TransparentColor:=clblack;
    image.Width  := OmegaImagelist.ImageList.items[OmegaImagelist.ImageList.Count-1].Picture.width ;
    image.height := OmegaImagelist.imagelist.items[OmegaImagelist.ImageList.Count-1].picture.height;
    lst_images.ItemIndex:=lst_images.items.Count-1;
    fill_edits;
  end;
  label5.Caption:=inttostr(lst_images.itemindex);
end;

procedure TForm1.btn_loadClick(Sender: TObject);
begin
  with opendialog1 do begin
    title:='Load imagelist';
    if execute then
      begin
        Clear;
        OmegaImagelist.ImageList.LoadFromFile(filename);
        lbl_filename.Caption:=filename;
        OmegaImagelist.init;
      end
      else
      exit;
  end;
  fill_lst;
  if lst_images.Count>0 then begin
    lst_images.ItemIndex:=0;
    lst_ImagesClick(nil);
  end;
end;

function Hex(Value: Cardinal): string;
begin
  Result := Format('%.6x', [Value]);
end;


procedure TForm1.lst_ImagesClick(Sender: TObject);
var ws,hs : string;  wi,hi : integer;
begin
  if lst_images.count>0 then
  begin
    image.Picture.Assign(OmegaImagelist.imagelist.items[lst_images.ItemIndex].Picture);
    image.Width := OmegaImagelist.ImageList.items[lst_images.itemindex].Picture.width ;
    image.height := OmegaImagelist.imagelist.items[lst_images.itemindex].picture.height;
    image.Repaint;
    StatusBar1.Panels[1].Text := inttostr(OmegaImagelist.imagelist.items[lst_images.ItemIndex].Picture.Width)+' x '+
                                 inttostr(OmegaImagelist.imagelist.items[lst_images.ItemIndex].Picture.Height);
  end;
  if lst_images.itemindex = -1 then exit; 
  fill_edits;
  if lst_images.itemindex <> -1 then label5.Caption:=inttostr(lst_images.itemindex);

  if (txt_Width.Text <> '') and (txt_Height.text <> '') then
      try
       ws := '0'; hs :='0';
       wi := StrToInt(txt_Width.Text);
       hi := StrToInt(txt_Height.Text);
       if wi <> 0 then
         ws := inttostr(OmegaImagelist.imagelist.items[lst_images.ItemIndex].Picture.Width div wi);
       if hi <> 0 then
         hs := inttostr(OmegaImagelist.imagelist.items[lst_images.ItemIndex].Picture.Height div hi);
      finally
       StatusBar1.Panels[5].Text := ws+' x '+hs;
      end;
end;

procedure TForm1.btn_saveClick(Sender: TObject);
begin
  with savedialog1 do begin
    title:='Save imagelist';
    if execute then OmegaImagelist.ImageList.SaveToFile(filename);
    lbl_filename.Caption:=filename;
  end;
end;

procedure TForm1.SpeedMovePictureUpClick(Sender: TObject);
var newidx : integer;
begin
  if lst_images.ItemIndex= -1 then exit;  
  if lst_images.Count <1  then exit;

  if (sender = SpeedMovePictureUp) and (lst_images.ItemIndex >0) then
  begin
     newidx :=  lst_images.ItemIndex-1;
     OmegaImagelist.imagelist.Items[lst_images.ItemIndex].Index := lst_images.ItemIndex-1;
     lst_Images.Items.Move(lst_images.ItemIndex,lst_images.ItemIndex-1);
  end
  else          
  if (sender = SpeedMovePictureDown) and (lst_images.ItemIndex < lst_images.Count-1) then
  begin                          
     newidx :=  lst_images.ItemIndex+1;
     OmegaImagelist.imagelist.Items[lst_images.ItemIndex].Index := lst_images.ItemIndex+1;
     lst_Images.Items.Move(lst_images.ItemIndex,lst_images.ItemIndex+1);
  end;
  lst_images.ItemIndex := newidx;
end;

procedure tform1.fill_lst;
var i: integer;
begin
  for i:=0 to OmegaImagelist.ImageList.Count-1 do
  lst_images.items.AddObject(OmegaImagelist.ImageList.Items[i].Name,OmegaImagelist.ImageList.Items[i]);
end;

procedure tform1.fill_edits;
begin
  PanelTransCol.Color:=OmegaImagelist.imagelist.items[lst_images.ItemIndex].TransparentColor;
  txt_name.text:=OmegaImagelist.imagelist.items[lst_images.ItemIndex].name;
  txt_width.text:=inttostr(OmegaImagelist.imagelist.items[lst_images.ItemIndex].tilewidth);
  txt_height.text:=inttostr(OmegaImagelist.imagelist.items[lst_images.ItemIndex].TileHeight);

  StatusBar1.Panels[1].Text := inttostr(OmegaImagelist.imagelist.items[lst_images.ItemIndex].Picture.Width)+' x '+
                                 inttostr(OmegaImagelist.imagelist.items[lst_images.ItemIndex].Picture.Height);
//  edit_width.text:=inttostr(imagelist.imagelist.items[lst_images.ItemIndex].picture.Width);
//  edit_height.text:=inttostr(imagelist.imagelist.items[lst_images.ItemIndex].Picture.Height);
  chb_trans.Checked:=OmegaImagelist.imagelist.items[lst_images.ItemIndex].Transparent;
  PanelTransCol.Color:=OmegaImagelist.imagelist.items[lst_images.ItemIndex].TransparentColor;
  PanelTransCol.Caption := '$'+hex(PanelTransCol.Color);
end;

procedure TForm1.txt_NameExit(Sender: TObject);
begin
  if OmegaImagelist.imagelist.Count<1 then exit;
  OmegaImagelist.imagelist.items[lst_images.ItemIndex].name:=txt_name.text;
  lst_images.Items[lst_images.ItemIndex]:=txt_name.text;
end;

procedure TForm1.txt_WidthExit(Sender: TObject);
begin
  if OmegaImagelist.imagelist.Count<1 then exit;
  OmegaImagelist.imagelist.items[lst_images.ItemIndex].tilewidth:=strtoint(txt_width.Text);
end;

procedure TForm1.txt_HeightExit(Sender: TObject);
begin
  if OmegaImagelist.imagelist.Count<1 then exit;
  OmegaImagelist.imagelist.items[lst_images.ItemIndex].tileheight:=strtoint(txt_height.Text);
end;

procedure TForm1.chb_transClick(Sender: TObject);
begin
  if OmegaImagelist.imagelist.Count<1 then exit;
  OmegaImagelist.imagelist.items[lst_images.ItemIndex].Transparent:=chb_trans.Checked;
end;

procedure TForm1.PanelTransColClick(Sender: TObject);
begin
  if OmegaImagelist.imagelist.Count<1 then exit;
  with colordialog1 do
  begin
    if execute then
    begin
     OmegaImagelist.imagelist.items[lst_images.ItemIndex].TransparentColor:=colordialog1.Color;
     PanelTransCol.Color:=colordialog1.Color;
     PanelTransCol.Caption := '$'+hex(PanelTransCol.Color);
    end;
  end;
end;

procedure TForm1.txt_OVWidthExit(Sender: TObject);
begin
  if OmegaImagelist.imagelist.Count<1 then exit;
//  imagelist.imagelist.items[lst_images.ItemIndex].OverrideWidth:=strtoint(txt_ovwidth.Text);
end;

procedure TForm1.chb_overrideClick(Sender: TObject);
begin
  if OmegaImagelist.imagelist.Count<1 then exit;
//  imagelist.imagelist.items[lst_images.ItemIndex].OverrideActual:=chb_override.Checked;
end;

procedure TForm1.btn_delClick(Sender: TObject);
var index: integer;
begin
  if OmegaImagelist.imagelist.Count<1 then exit;

  if MessageDlg('Delete this image?', mtConfirmation, [mbYes, mbNo], 0) = mrNO then exit;

  index:=lst_images.ItemIndex;
  OmegaImagelist.imagelist.Delete(lst_images.ItemIndex);
  lst_images.Items.Delete(lst_images.itemindex);
  label5.Caption:=inttostr(lst_images.itemindex);
  if (lst_images.itemindex<0) and (OmegaImagelist.imagelist.Count>0) then lst_images.itemindex:=0 else
  if lst_images.itemindex-1<OmegaImagelist.imagelist.Count then lst_images.ItemIndex:=index-1;
  lst_images.SetFocus;
  lst_ImagesClick(Sender);
end;

procedure TForm1.Quit1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  btn_loadclick(nil);
end;

procedure TForm1.SaveImagelist1Click(Sender: TObject);
begin
  btn_saveclick(nil);
end;

procedure TForm1.AddImage1Click(Sender: TObject);
begin
  btn_addclick(nil);
end;

procedure TForm1.DeleteImage1Click(Sender: TObject);
begin
  btn_delclick(nil);
end;

procedure TForm1.NewImagelist1Click(Sender: TObject);
begin
  btn_newclick(nil);
end;

procedure TForm1.btn_newClick(Sender: TObject);
begin
  OmegaTimer1.Enabled := false;
  Clear;
end;

procedure TForm1.clear;
begin
  lst_images.clear;
  OmegaImagelist.ImageList.Clear;
  templist.ImageList.clear;
  Image.Canvas.FloodFill(10,10,0,fsBorder);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  frm_info.ShowModal;
end;

procedure TForm1.OpenDialog1Show(Sender: TObject);
begin
  opendialog1.filename:='*.OIL';
end;

procedure TForm1.btn_ChangeClick(Sender: TObject);
var picture: tpicture;
begin
  with openpicturedialog do begin
    title:='Load image';
    if execute then image.Picture.LoadFromFile(openpicturedialog.FileName);
    picture:=tpicture.Create;
    picture.LoadFromFile(filename);
    image.Width  := OmegaImagelist.ImageList.items[lst_images.itemindex].Picture.width ;
    image.height := OmegaImagelist.imagelist.items[lst_images.itemindex].picture.height;
    OmegaImagelist.ImageList.Items[lst_images.itemindex].SetPicture(picture);
    OmegaImagelist.ImageList.Items[lst_images.itemindex].SetPicture(picture);
    OmegaImagelist.ImageList.Items[lst_images.itemindex].Name:=extractfilename(filename);
    OmegaImagelist.ImageList.items[lst_images.itemindex].DisplayName := extractfilename(filename);
    OmegaImagelist.ImageList.Items[lst_images.itemindex].TileHeight:=picture.Height;
    OmegaImagelist.ImageList.Items[lst_images.itemindex].Tilewidth:=picture.Width;
    OmegaImagelist.ImageList.Items[lst_images.itemindex].Transparent:=true;
    OmegaImagelist.ImageList.Items[lst_images.itemindex].TransparentColor:=clblack;
//    imagelist.ImageList.Items[lst_images.itemindex].OverrideActual:=false;
//    imagelist.ImageList.Items[lst_images.itemindex].OverrideWidth:=0;
    image.Width  := OmegaImagelist.ImageList.items[lst_images.itemindex].Picture.width ;
    image.height := OmegaImagelist.imagelist.items[lst_images.itemindex].picture.height;
    image.Picture.Assign(OmegaImagelist.imagelist.items[lst_images.ItemIndex].Picture);
    image.Repaint;
    lst_images.Items[lst_images.ItemIndex]:=extractfilename(filename);
    fill_edits;
  end;  
end;

procedure TForm1.ChangeImage1Click(Sender: TObject);
begin                   
  if lst_images.itemindex = -1 then exit;
  
  btn_changeclick(nil);
end;

procedure TForm1.SaveImage1Click(Sender: TObject);
begin
  if lst_images.itemindex = -1 then exit;

  savepicturedialog1.FileName:=OmegaImagelist.imagelist.Items[lst_images.itemindex].Name;
  if OmegaImagelist.imagelist.Count<1 then exit;
  with savepicturedialog1 do begin
    if execute then OmegaImagelist.imagelist.Items[lst_images.itemindex].Picture.SaveToFile(filename);
  end;  
end;


// In this example, we use XOR-encryption with periodic modulation
// of key offset, defined by initial condition 'password'
function MyEncrypt(s: TStream): TStream;
var arrbyte: array of byte;
    i, size: Integer;
    Key: Word;
begin
 size := s.Size; SetLength(arrbyte, size);
 s.Position := 0; s.Read(arrbyte[0], SizeOf(arrbyte[0]) * size);
 Key := password;
 for i := 0 to High(arrbyte) do // for every byte in the stream
 begin
  arrbyte[i] := arrbyte[i] xor (Key shr 8);
  Key := (arrbyte[i] + Key) * C1 + C2;
 end;
 s.Position := 0; s.Write(arrbyte[0], SizeOf(arrbyte[0]) * size);
 result := s;
end;

function MyDecrypt(s: TStream): TStream;
var arrbyte: array of byte;
    i, size: Integer;
    r: byte;
    Key: Word;
begin
 size := s.Size; SetLength(arrbyte, size);
 s.Position := 0; s.Read(arrbyte[0], SizeOf(arrbyte[0]) * size);
 Key := password;
 for i := 0 to High(arrbyte) do // for every byte in the stream
 begin
  r := arrbyte[i];
  arrbyte[i] := arrbyte[i] xor (Key shr 8);
  Key := (r + Key) * C1 + C2;
 end;
 s.Position := 0; s.Write(arrbyte[0], SizeOf(arrbyte[0]) * size);
 result := s;
end;

procedure TForm1.LoadcryptedImagelist1Click(Sender: TObject);
begin
 if password = 0 then
   begin
    ShowMessage('Enter a encryption code first');
    exit;
   end;

  with opendialog1 do begin
    title:='Load imagelist';
    if execute then
      begin
        Clear;
        OmegaImagelist.ImageList.DecodeFunction := MyDecrypt;
        OmegaImagelist.ImageList.LoadFromFile(OpenDialog1.Filename);
        OmegaImagelist.Init;
        lbl_filename.Caption:=filename;
      end
      else
      exit;
  end;
  fill_lst;
  lst_images.ItemIndex:=0;
  lst_ImagesClick(nil);
end;

procedure TForm1.SavecryptedImagelist1Click(Sender: TObject);
begin
  with savedialog1 do begin
    title:='Save imagelist';
    if execute then
    begin
      OmegaImagelist.ImageList.EncodeFunction := MyEncrypt;
      OmegaImagelist.ImageList.SaveToFile(SaveDialog1.Filename);
    end;
    lbl_filename.Caption:=filename;
  end;
end;


//------------------------------------------------------------------------------
// WriteIntegerToConfigFile
//------------------------------------------------------------------------------
Function TForm1.WriteIntegerToConfigFile(Section, Value : string; DefaultValue : Integer) : boolean;
var MyIni : Tinifile;
    Temp  : integer;
begin
 Result  := False;
 try
  MyIni   := Tinifile.Create(ExtractFilePath(paramstr(0))+'config.ini');
  MyIni.WriteInteger(Section, Value,  DefaultValue);
  Result  := true;
 Finally
  MyIni.UpdateFile;
  MyIni.Free;
 end;
end;

Function TForm1.ReadIntegerFromConfigIni(Section, Value : string; DefaultValue : Integer) : integer;
var MyIni : Tinifile;
begin
 Result := 0;
 Try
  MyIni := Tinifile.create(ExtractFilePath(paramstr(0))+'config.ini');
  if Myini.ValueExists(Section, Value) then Result := myini.ReadInteger(Section, value, DefaultValue)
  else
    begin
     myini.WriteInteger(Section, value, DefaultValue);
     Result := DefaultValue
    end
 finally
  MyIni.UpdateFile;
  MyIni.Free;
 end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  randomize;
  OmegaScreen1.Width := panel1.ClientWidth;
  OmegaScreen1.Height := panel1.ClientHeight;

  OmegaScreen1.SethWnd(panel1.Handle);
  OmegaScreen1.Init;

  
  PanelGlobalCol.color := ReadIntegerFromConfigIni('Colour', 'GlobalColour', clFuchsia);

  TrackBarAnimate.Position := ReadIntegerFromConfigIni('Animate', 'Speed', 50);
  LabelSpeed.caption := IntTostr(TrackBarAnimate.Position)+'ms';

  password := ReadIntegerFromConfigIni('encryption', 'code', -1);
  if password = -1 then
  begin
    EnterEncryptionCode;
  end
  else
   begin
    ToolButtonKey.Down := true;
    self.Caption := 'Omega Imagelist-Editor (encryption code entered)';
    ToolButtonOpenEncrypt.Enabled := true;
    ToolButtonSaveEncrypt.Enabled := true;
   end;
end;

procedure TForm1.ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  StatusBar1.Panels[3].Text := inttostr(x)+' x '+
                               inttostr(y);

  if lst_Images.Count>0 then
  try
  PanelMouseOverCol.Color:=image.Canvas.Pixels[x,y];
  PanelMouseOverCol.Caption := '$'+hex(PanelMouseOverCol.Color);
  except;
  end;
end;

procedure TForm1.ButtonAddImageClick(Sender: TObject);
var picture: tpicture;
    i: integer;
begin
  with openpicturedialog1 do begin
    title:='Load image';
    if execute then image.Picture.LoadFromFile(openpicturedialog1.FileName);
    if openpicturedialog1.Files.Count>1 then openpicturedialog1.Files.Exchange(0,openpicturedialog1.Files.Count-1);
    for i:=0 to openpicturedialog1.Files.Count-1 do begin
      OmegaImagelist.ImageList.Add;
      lst_Images.Items.AddObject(extractfilename(openpicturedialog1.Files[i]),image);
      picture:=tpicture.Create;
      picture.LoadFromFile(openpicturedialog1.Files[i]);
      OmegaImagelist.ImageList.Items[OmegaImagelist.ImageList.Count-1].SetPicture(picture);
      OmegaImagelist.ImageList.Items[OmegaImagelist.ImageList.Count-1].Name:=extractfilename(openpicturedialog1.Files[i]);
      OmegaImagelist.ImageList.items[OmegaImagelist.imagelist.count-1].DisplayName := extractfilename(openpicturedialog1.Files[i]);
      OmegaImagelist.ImageList.Items[OmegaImagelist.ImageList.Count-1].TileHeight:=picture.Height;
      OmegaImagelist.ImageList.Items[OmegaImagelist.ImageList.Count-1].Tilewidth:=picture.Width;
      OmegaImagelist.ImageList.Items[OmegaImagelist.ImageList.Count-1].Transparent:=true;

      image.Width  := OmegaImagelist.ImageList.items[OmegaImagelist.ImageList.Count-1].Picture.width ;
      image.height := OmegaImagelist.imagelist.items[OmegaImagelist.ImageList.Count-1].picture.height;
    end;
    lst_images.ItemIndex:=lst_images.items.Count-1;
    fill_edits;
  end;
  label5.Caption:=inttostr(lst_images.itemindex);
  OmegaImagelist.Init;
end;

procedure TForm1.PanelGlobalColClick(Sender: TObject);
var i: integer;
begin
  if MessageDlg('Set the same transparent colour for all images?', mtWarning, [mbYes,mbNo], 0) = mrNo then exit;

  with colordialog1 do
  begin
    if (execute) then
    begin
     PanelGlobalCol.Color:=colordialog1.Color;
     for i:=0 to OmegaImagelist.ImageList.Count-1 do
       OmegaImagelist.ImageList.Items[i].TransparentColor:=PanelGlobalCol.color;

     PanelTransCol.Color:=colordialog1.Color;
     WriteIntegerToConfigFile('Colour', 'GlobalColour', PanelTransCol.Color);
    end;
  end;
end;



procedure TForm1.ImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin                     
  if OmegaImagelist.imagelist.Count<1 then exit;
  PanelTransCol.Color := PanelMouseOverCol.color;
  PanelTransCol.Caption := '$'+hex(PanelTransCol.Color);

  OmegaImagelist.imagelist.items[lst_images.ItemIndex].TransparentColor:=PanelTransCol.Color;
end;

procedure TForm1.RememberEncryption1Click(Sender: TObject);
begin

 if password = 0 then EnterEncryptionCode;

 if ToolButtonKey.down then
   begin                                                 
     self.Caption := 'Omega Imagelist-Editor (encryption code entered)';
    WriteIntegerToConfigFile('encryption', 'code', password);
   end
   else
   begin                                             
    self.Caption := 'Omega Imagelist-Editor';
    WriteIntegerToConfigFile('encryption', 'code', -1);
    password := 0;
   end;
end;

procedure TForm1.EnterEncryptionCode;
var spass: string;
begin
    spass:=inputbox('Password', 'Enter your numeric code to encrypt your imagelists (leave 0 for none)','0');
    try
      password:=strtoint(spass);
    except
      password := 0;
    end;
    if password = 0 then
    begin
     self.Caption := 'Omega Imagelist-Editor';
     ToolButtonOpenEncrypt.Enabled := false;
     ToolButtonSaveEncrypt.Enabled := false;
    end
    else
    begin
     self.Caption := 'Omega Imagelist-Editor (encryption code entered)';
     ToolButtonOpenEncrypt.Enabled := true;
     ToolButtonSaveEncrypt.Enabled := true;
    end;
end;

procedure TForm1.Enterencryptioncode1Click(Sender: TObject);
begin
 EnterEncryptionCode;   
 WriteIntegerToConfigFile('encryption', 'code', password)
end;

procedure TForm1.FormResize(Sender: TObject);
begin
// ScrollBoxDisplay.Width  := self.Width  - ScrollBoxDisplay.left-20;
// ScrollBoxDisplay.height := self.height - ScrollBoxDisplay.top -50;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (key = vk_escape) then
  if (MessageDlg('Close application?', mtConfirmation, [mbYes, mbNo], 0) = mrNO) then exit else close;

end;

procedure TForm1.txt_HeightKeyPress(Sender: TObject; var Key: Char);
const AllowableKeys = ['0','1','2','3','4','5','6','7','8','9'];
begin
 if not (key in AllowableKeys) then key := #0;
end;

procedure TForm1.OmegaTimer1Timer(Sender: TObject);
var px, py : integer;
begin
  if not OmegaScreen1.CanDraw then exit;
//  if lst_images.ItemIndex= -1 then exit;
//  if lst_images.ItemIndex> lst_Images.Count-1 then exit;

  OmegaScreen1.BeginRender;
  OmegaScreen1.ClearScreen(0, 0, 0, 0);

  if TimeGetTime > Anim then
   begin
    Anim := TimeGetTime + TrackBarAnimate.Position;
    inc(curcel);
    if Curcel > ((OmegaImagelist.ImageList.Items[lst_images.ItemIndex].NumOfRows * OmegaImagelist.ImageList.Items[lst_images.ItemIndex].NumOfColumns)-1) then curcel := 0;
   end;

  px := (panel1.Width div 2)  - (OmegaImagelist.ImageList.Items[lst_images.ItemIndex].TileWidth div 2);
  py := (panel1.height div 2) - (OmegaImagelist.ImageList.Items[lst_images.ItemIndex].Tileheight div 2);

  OmegaImagelist.ImageList.Items[lst_images.ItemIndex].Draw(px, py, curcel);

  LabelCurCel.caption := 'Current cell: '+IntToStr(Curcel);

  OmegaScreen1.EndRender;
end;

procedure TForm1.SpeedButtonStartClick(Sender: TObject);
begin
 OmegaTimer1.Enabled := not OmegaTimer1.Enabled;
end;

procedure TForm1.TrackBarAnimateChange(Sender: TObject);
begin
 WriteIntegerToConfigFile('Animate', 'Speed', TrackBarAnimate.Position);
 LabelSpeed.caption := IntTostr(TrackBarAnimate.Position)+'ms';
end;

procedure TForm1.ButtonGlobWidthClick(Sender: TObject);
var i : integer;
begin
  if EditTileWidth.Text = '' then exit;   
  if OmegaImagelist.ImageList.Count = 0 then exit;

  if MessageDlg('Set the same tile width for all images?', mtWarning, [mbYes,mbNo], 0) = mrNo then exit;

  for i:=0 to OmegaImagelist.ImageList.Count-1 do
   try
    OmegaImagelist.ImageList.Items[i].tilewidth:=strtoint(EditTileWidth.text);
   except
    OmegaImagelist.ImageList.Items[i].tilewidth:=OmegaImagelist.ImageList.Items[i].Picture.Width;
   end;
end;

procedure TForm1.ButtonSetGlobalTileHeigthClick(Sender: TObject);
var i : integer;
begin
  if EditTileHeight.Text = '' then exit;
  if OmegaImagelist.ImageList.Count = 0 then exit;

  if MessageDlg('Set the same tile height for all images?', mtWarning, [mbYes,mbNo], 0) = mrNo then exit;

  for i:=0 to OmegaImagelist.ImageList.Count-1 do
   try
    OmegaImagelist.ImageList.Items[i].TileHeight:=strtoint(EditTileHeight.text);
   except
    OmegaImagelist.ImageList.Items[i].TileHeight:=OmegaImagelist.ImageList.Items[i].Picture.height;
   end;

end;

end.
